@using Entities
@using Business
@using DataAccess

@inject IDbContextFactory<inventory_context> ContextFactory;

@if (DataLoading)
{
    <h4>@loading_message</h4>
}

<select class="form-control" @onchange="CategoryChanged">
    @foreach (var category in categories)
    {
        <option value="none" selected disabled hidden>Elige una Categoria ..</option>
        <option value="@category.CatId">@category.CatName</option>
    }
</select>
<br>

<div>
    <table class="table table-hover table-bordered">
        <thead>
            <tr>
                <th>Item</th>
                <th>Referencia</th>
                <th>Nombre de Producto</th>
                <th>Descripcion</th>
                <th>Cantidad</th>
                <th>Acciones</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var product in temp_products)
            {
                <tr>
                    <td>@product.ProdId</td>
                    <td>@product.ProdCode</td>
                    <td>@product.ProdName</td>
                    <td>@product.ProdDescription</td>
                    <td>@product.TotalQuantity</td>
                    <td>
                        <a href="product/edit/@product.ProdId">
                            <button class="btn btn-primary">Editar</button>                        
                        </a>
                    </td>                    
                </tr>
            }
        </tbody>
    </table>
</div>

<h4>@message</h4>

@code
{
    private bool DataLoading = false;
    private string loading_message = "Fetching products from DB ...";
    private string message = string.Empty;
    List<Product> products = new();
    List<Product> temp_products = new();
    List<Category> categories = new();

    B_Product bProduct = null!;
    B_Category bCategory = null!;

    protected override async Task OnInitializedAsync()
    {
        if (DataLoading) 
        {
            return;
        }

        try
        {
            DataLoading = true;
            
            bProduct = new (ContextFactory);
            bCategory = new(ContextFactory);

            if (bProduct is not null && bCategory is not null)
            {
                products = await bProduct!.GetProducts();
                categories = await bCategory.GetCategories();

                temp_products = products;

            }
        }
        catch (System.Exception ex)
        {
            throw ex;
        }
        finally
        {
            DataLoading = false;
        }
        await base.OnInitializedAsync();
    }

    private void CategoryChanged(ChangeEventArgs e)
    {
        var id_str = e.Value?.ToString();
        var cat_id = int.Parse(id_str);        
        temp_products = products.Where(c => c.CatId == cat_id).ToList();
    }
}